﻿Public Class frmLoan
  Dim ComputePayment As Boolean
  Private Sub btnCompute_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCompute.Click
    Dim Balance As Double
    Dim Interest As Double
    Dim Months As Integer
    Dim Payment As Double
    Dim MonthlyInterest As Double
    Dim Multiplier As Double
    Dim LoanBalance As Double
    Dim FinalPayment As Double
    Dim PaymentNumber As Integer
    If txtBalance.Text <> "" Then
      Balance = Val(txtBalance.Text)
    Else
      MessageBox.Show("Must enter a Loan Balance value.", "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Information)
      txtBalance.Focus()
      Return
    End If
    If txtInterest.Text <> "" Then
      Interest = Val(txtInterest.Text)
    Else
      MessageBox.Show("Must enter an Interest Rate value.", "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Information)
      txtInterest.Focus()
      Return
    End If
    MonthlyInterest = Interest / 1200
    If ComputePayment Then
      'Compute loan payment
      If txtMonths.Text <> "" Then
        Months = Val(txtMonths.Text)
      Else
        MessageBox.Show("Must enter a Number of Months value.", "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Information)
        txtMonths.Focus()
        Return
      End If
      If Interest = 0 Then
        Payment = Balance / Months
      Else
        Multiplier = CDbl((1 + MonthlyInterest) ^ Months)
        Payment = Balance * MonthlyInterest * Multiplier / (Multiplier - 1)
      End If
      txtPayment.Text = Format(Payment, "0.00")
    Else
      'Compute number of payments
      If txtPayment.Text <> "" Then
        Payment = Val(txtPayment.Text)
        If Payment <= (Balance * MonthlyInterest + 1.0) Then
          If MessageBox.Show("Minimum payment must be " + Format(CInt(Balance * MonthlyInterest + 1.0), "$0.00") + ControlChars.CrLf + "Do you want to use the minimum payment?", "Input Error", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = Windows.Forms.DialogResult.Yes Then
            txtPayment.Text = Format(CInt(Balance * MonthlyInterest + 1.0), "0.00")
            Payment = Val(txtPayment.Text)
          Else
            txtPayment.Focus()
            Return
          End If
        End If
      Else
        MessageBox.Show("Must enter a Monthly Payment value.", "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Information)
        txtPayment.Focus()
        Return
      End If
      If Interest = 0 Then
        Months = CInt(Balance / Payment)
      Else
        Months = CInt((Math.Log(Payment) - Math.Log(Payment - Balance * MonthlyInterest)) / Math.Log(1 + MonthlyInterest))
      End If
      txtMonths.Text = Format(Months, "0")
    End If
    'reset payment prior to analysis to fix at two decimals
    Payment = Val(txtPayment.Text)
    'show analysis
    txtAnalysis.Text = "Loan Balance: " + Format(Balance, "$0.00")
    txtAnalysis.Text += ControlChars.CrLf + "Interest Rate: " + Format(Interest, "0.00") + "%"
    'process all but last payment
    LoanBalance = Balance
    For PaymentNumber = 1 To Months - 1
      LoanBalance += LoanBalance * MonthlyInterest - Payment
    Next PaymentNumber
    'find final payment
    FinalPayment = LoanBalance
    If FinalPayment > Payment Then
      'apply one more payment
      LoanBalance += LoanBalance * MonthlyInterest - Payment
      FinalPayment = LoanBalance
      Months += 1
      txtMonths.Text = Format(Months, "0")
    End If
    txtAnalysis.Text += ControlChars.CrLf + ControlChars.CrLf + Format(Months - 1, "0") + " Payments of " + Format(Payment, "$0.00")
    txtAnalysis.Text += ControlChars.CrLf + "Final Payment of: " + Format(FinalPayment, "$0.00")
    txtAnalysis.Text += ControlChars.CrLf + "Total Payments: " + Format((Months - 1) * Payment + FinalPayment, "$0.00")
    txtAnalysis.Text += ControlChars.CrLf + "Interest Paid " + Format((Months - 1) * Payment + FinalPayment - Balance, "$0.00")
    btnCompute.Enabled = False
    btnNewLoan.Enabled = True
    btnNewLoan.Focus()
  End Sub

  Private Sub frmLoan_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    btnPayment.PerformClick()
  End Sub

  Private Sub btnMonths_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnMonths.Click
    ' will compute months
    ComputePayment = False
    btnPayment.Visible = True
    btnMonths.Visible = False
    txtMonths.Text = ""
    txtMonths.ReadOnly = True
    txtMonths.TabStop = False
    txtMonths.BackColor = Color.LightYellow
    txtPayment.ReadOnly = False
    txtPayment.TabStop = True
    txtPayment.BackColor = Color.White
    btnCompute.Text = "Compute Number of Payments"
    txtBalance.Focus()
  End Sub

  Private Sub btnPayment_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPayment.Click
    ' will compute payment
    ComputePayment = True
    btnPayment.Visible = False
    btnMonths.Visible = True
    txtMonths.ReadOnly = False
    txtMonths.TabStop = True
    txtMonths.BackColor = Color.White
    txtPayment.Text = ""
    txtPayment.ReadOnly = True
    txtPayment.TabStop = False
    txtPayment.BackColor = Color.LightYellow
    btnCompute.Text = "Compute Monthly Payment"
    txtBalance.Focus()
  End Sub

  Private Sub btnNewLoan_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNewLoan.Click
    'clear computed value and analysis
    If ComputePayment Then
      txtPayment.Text = ""
    Else
      txtMonths.Text = ""
    End If
    txtAnalysis.Text = ""
    btnCompute.Enabled = True
    btnNewLoan.Enabled = False
    txtBalance.Focus()
  End Sub

  Private Sub txtBalance_KeyPress(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtBalance.KeyPress
    'only allow numbers, a single decimal point, backspace  or enter        
    Select Case e.KeyChar
      Case "0"c To "9"c, ControlChars.Back
        'acceptable keystrokes 
        e.Handled = False
      Case ControlChars.Cr
        'enter key - move to next box
        txtInterest.Focus()
        e.Handled = False
      Case "."c
        'check for existence of decimal point
        If InStr(txtBalance.Text, ".") = 0 Then
          e.Handled = False
        Else
          e.Handled = True
        End If
      Case Else
        e.Handled = True
    End Select
  End Sub

  Private Sub txtInterest_KeyPress(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtInterest.KeyPress
    'only allow numbers, a single decimal point, backspace  or enter        
    Select Case e.KeyChar
      Case "0"c To "9"c, ControlChars.Back
        'acceptable keystrokes 
        e.Handled = False
      Case ControlChars.Cr
        'enter key - move to next box
        If ComputePayment Then
          txtMonths.Focus()
        Else
          txtPayment.Focus()
        End If
        e.Handled = False
      Case "."c
        'check for existence of decimal point
        If InStr(txtInterest.Text, ".") = 0 Then
          e.Handled = False
        Else
          e.Handled = True
        End If
      Case Else
        e.Handled = True
    End Select
  End Sub

  Private Sub txtMonths_KeyPress(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtMonths.KeyPress
    'only allow numbers, backspace  or enter        
    Select Case e.KeyChar
      Case "0"c To "9"c, ControlChars.Back
        'acceptable keystrokes 
        e.Handled = False
      Case ControlChars.Cr
        'enter key - move to compute button
        btnCompute.Focus()
        e.Handled = False
      Case Else
        e.Handled = True
    End Select

  End Sub

  Private Sub txtPayment_KeyPress(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtPayment.KeyPress
    'only allow numbers, a single decimal point, backspace  or enter        
    Select Case e.KeyChar
      Case "0"c To "9"c, ControlChars.Back
        'acceptable keystrokes 
        e.Handled = False
      Case ControlChars.Cr
        'enter key - move to compute button
        btnCompute.Focus()
        e.Handled = False
      Case "."c
        'check for existence of decimal point
        If InStr(txtPayment.Text, ".") = 0 Then
          e.Handled = False
        Else
          e.Handled = True
        End If
      Case Else
        e.Handled = True
    End Select
  End Sub

  Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
    Me.Close()
  End Sub
End Class
